/*******************************************************************
 *	EX-Window Ver.2.0 X file.
 *	(c) i.kikuchi & i.yoshida
 *	
    24bit color modified for layman
    $Id: huemove.c,v 1.3 1998/08/28 15:46:30 TANE Exp $
*******************************************************************/

#include 	"common.h"
#include	"funcs.h"
#include	"huemove.h"
#include	"hsv_rgb.h"

int	huemove( struct VGRAM_STRUCT *vg_pt , struct HUEMOVE_EXEC_STRUCT *exec_info )
{
int	x0,y0,x1,y1 ;
int	x, y ;
int	h, s, v, r, g, b, a, or, og, ob, dh ;
int	height , width ;
register struct PIX_STRUCT	*pix_pt ;

	x0 = exec_info->x0 ;
	y0 = exec_info->y0 ;
	x1 = exec_info->x1 ;
	y1 = exec_info->y1 ;
	dh = exec_info->dh ;
	pix_pt = vg_pt->pix ;
	width  = x1 - x0 + 1 ;
	height = y1 - y0 + 1 ;

	if( exec_info->mask == ON ){
		for( y=y0; y<=y1; y++ ){
			for( x=x0; x<=x1; x++ ){
				g = pix_pt[x+y*width].g ;
				r = pix_pt[x+y*width].r ;
				b = pix_pt[x+y*width].b ;
				a = pix_pt[x+y*width].a ;
				switch( a ){
					case VALUE_MAX :
						break ;
					case 0 :
						RGBtoHSV( r, g, b, &h, &s, &v );
						h = (h+dh) ;
						if( h<0 ) h=h + HUE_RANGE ;
						h=h % HUE_RANGE;
						HSVtoRGB( h, s, v, &r, &g, &b );
						pix_pt[x+y*width].g = g ;
						pix_pt[x+y*width].r = r ;
						pix_pt[x+y*width].b = b ;
						break ;
					default :
						og = g ;
						or = r ;
						ob = b ;
						RGBtoHSV( r, g, b, &h, &s, &v );
						h = (h+dh) ;
						if( h<0 ) h=h + HUE_RANGE ;
						h=h % HUE_RANGE;
						HSVtoRGB( h, s, v, &r, &g, &b );
						pix_pt[x+y*width].g = mix_col( og, g, a, VALUE_MAX ) ;
						pix_pt[x+y*width].r = mix_col( or, r, a, VALUE_MAX ) ;
						pix_pt[x+y*width].b = mix_col( ob, b, a, VALUE_MAX ) ;
				}
			}
		}
	}else{
		for( y=y0; y<=y1; y++ ){
			for( x=x0; x<=x1; x++ ){
				g = pix_pt[x+y*width].g ;
				r = pix_pt[x+y*width].r ;
				b = pix_pt[x+y*width].b ;
				RGBtoHSV( r, g, b, &h, &s, &v );
				h = (h+dh) ;
				if( h<0 ) h=h + HUE_RANGE ;
				h=h % HUE_RANGE;
				HSVtoRGB( h, s, v, &r, &g, &b );
				pix_pt[x+y*width].g = g ;
				pix_pt[x+y*width].r = r ;
				pix_pt[x+y*width].b = b ;
			}
		}
	}
	return( NORMAL_EXIT ) ;
}

