/**********************************************************************
  WAW`
  $Id: julia.c,v 1.5 1998/09/03 14:44:32 TANE Exp $
**********************************************************************/
#include	"common.h"
#include	"julia.h"
#include	"funcs.h"
#include	"hsv_rgb.h"
#include	<math.h>

unsigned int	fr_calc(double, double, double, double);

int	julia( struct VGRAM_STRUCT *vg_pt, struct JULIA_EXEC_STRUCT *exec_info )
{
int		i, j ;
//int		r,g,b ;
unsigned int p ;
double	ii,jj ;
double	re,im ;

/*  -0.05     -0.86                   */
/*  -0.25     -0.74                   */
/*  -0.15     -0.65                   */
/*  -0.19      0.66                   */

	re = exec_info->re ;
	im = exec_info->im ;

	for ( i=0 ; i<=exec_info->width ; i++ ){
		for ( j=0 ; j<=exec_info->height ; j++ ){
//			ii=((double)i*2/(exec_info->width +1))-1 ;
//			jj=((double)j*2/(exec_info->height+1))-1 ;
			ii=((double)(((i-exec_info->width /2)/exec_info->by)+exec_info->width /2)*2/(exec_info->width +1))-1 ;
			jj=((double)(((j-exec_info->height/2)/exec_info->by)+exec_info->height/2)*2/(exec_info->height+1))-1 ;
			p=fr_calc(ii,jj,re,im) ;
			if( i>=vg_pt->width || j>=vg_pt->height ) continue ;
//			p = (exec_info->hue-p) % HUE_RANGE ;
//			HSVtoRGB( p, VALUE_MAX, VALUE_MAX, &r, &g, &b ) ;
//			vg_pt->pix[i+j*vg_pt->width].g = g ;
//			vg_pt->pix[i+j*vg_pt->width].r = r ;
//			vg_pt->pix[i+j*vg_pt->width].b = b ;
			vg_pt->pix[i+j*vg_pt->width].g = p % 256 ;
			vg_pt->pix[i+j*vg_pt->width].r = p % 256 ;
			vg_pt->pix[i+j*vg_pt->width].b = p % 256 ;
		}
	}
	return( NORMAL_EXIT ) ;
}
/***************************/
unsigned int fr_calc(double f1,double f2, double re, double im)
{
int	i;
double	a,b,c,e;

	i=1 ;
	a=f1;
	b=f2;
	do {
		c= a*a - b*b + re ;
		b=((a*b)*2)+im ;
		a=c ;
		e=sqrt((a*a+b*b)/2) ;
		if ( e>(65536*1000) ) break;
		else       i=i+1;
	} while (!(i>=(256*8)));
//	fprintf(stderr,"result=%d\n",i) ;
	return( (unsigned int)i );
}
