/**********************************************************************
  line sC
  $Id: line.c,v 1.3 1999/05/31 15:43:56 TANE Exp $
**********************************************************************/
#include	"common.h"
#include	"line.h"
#include	"funcs.h"
#include	"hsv_rgb.h"

void buildgamma( unsigned char* , double ) ;

int	put_line( struct VGRAM_STRUCT *vg_pt, struct LINE_EXEC_STRUCT *exec_info )
{
int		dx,dy ;
int		sx,sy ;
int		x , y ;
int		i ;

int		r,g,b ;		//,a ;
PIX_ELM_DEPTH	rb,gb,bb ;	//,a ;
unsigned char	*g_tbl ;

int		width,tran1,tran2 ;
register struct PIX_STRUCT	*pix_pt ;

	pix_pt = vg_pt->pix ;
	width = vg_pt->width ;
	if( exec_info->oper == HSV_COLOR ){
		HSVtoRGB( exec_info->h, exec_info->s, exec_info->v, &r, &g, &b );
	}else{
		r = exec_info->r ;
		g = exec_info->g ;
		b = exec_info->b ;
	}

	if( exec_info->x0>exec_info->x1 ){
		i=exec_info->x0 ; exec_info->x0=exec_info->x1 ; exec_info->x1=i ;
		i=exec_info->y0 ; exec_info->y0=exec_info->y1 ; exec_info->y1=i ;
	}

	dx=iabs( exec_info->x1 - exec_info->x0 ) ;
	dy=iabs( exec_info->y1 - exec_info->y0 ) ;
	if( dx==0 && dy==0 ){
		pix_pt[exec_info->x0+exec_info->y0*width].r = r ;
		pix_pt[exec_info->x0+exec_info->y0*width].g = g ;
		pix_pt[exec_info->x0+exec_info->y0*width].b = b ;
		return( NORMAL_EXIT ) ;
	}

	g_tbl = malloc( VALUE_MAX+1 ) ;
	if( g_tbl == NULL ) return(WORK_MEM_ALLOC_ERROR) ;
	buildgamma( g_tbl, 0.6 );

	sx=isgn( exec_info->x1 - exec_info->x0 );
	sy=isgn( exec_info->y1 - exec_info->y0 );

	if( dx<dy ){
		if( sy>0 ){
			for( i=0 ; i<=dy ; i++ ){
				tran1=(dx*(i*256)/dy) % 256 ;
				tran2=VALUE_MAX-tran1 ;
				tran1=g_tbl[tran1] ;
				tran2=g_tbl[tran2] ;
				x=exec_info->x0 + (dx*i/dy) ;
				y=exec_info->y0 + i ;
				if( x>=0 && y>=0 && x<vg_pt->width && y<vg_pt->height ){
					rb = pix_pt[x+y*width].r ;
					pix_pt[x+y*width].r = mix_col(rb,r,tran1,VALUE_MAX) ;
					gb = pix_pt[x+y*width].g ;
					pix_pt[x+y*width].g = mix_col(gb,g,tran1,VALUE_MAX) ;
					bb = pix_pt[x+y*width].b ;
					pix_pt[x+y*width].b = mix_col(bb,b,tran1,VALUE_MAX) ;
				}

				if( (x+1)>=0 && y>=0 && (x+1)<vg_pt->width && y<vg_pt->height ){
					rb = pix_pt[x+1+y*width].r ;
					pix_pt[x+1+y*width].r = mix_col(rb,r,tran2,VALUE_MAX) ;
					gb = pix_pt[x+1+y*width].g ;
					pix_pt[x+1+y*width].g = mix_col(gb,g,tran2,VALUE_MAX) ;
					bb = pix_pt[x+1+y*width].b ;
					pix_pt[x+1+y*width].b = mix_col(bb,b,tran2,VALUE_MAX) ;
				}
			}
		}else{
			for( i=0 ; i<=dy ; i++ ){
				tran1=(dx*(i*256)/dy) % 256 ;
				tran2=VALUE_MAX-tran1 ;
				tran1=g_tbl[tran1] ;
				tran2=g_tbl[tran2] ;
				x=exec_info->x0 + (dx*i/dy) ;
				y=exec_info->y0 - i ;
				if( x>=0 && y>=0 && x<vg_pt->width && y<vg_pt->height ){
					rb = pix_pt[x+y*width].r ;
					pix_pt[x+y*width].r = mix_col(rb,r,tran1,VALUE_MAX) ;
					gb = pix_pt[x+y*width].g ;
					pix_pt[x+y*width].g = mix_col(gb,g,tran1,VALUE_MAX) ;
					bb = pix_pt[x+y*width].b ;
					pix_pt[x+y*width].b = mix_col(bb,b,tran1,VALUE_MAX) ;
				}

				if( (x+1)>=0 && y>=0 && (x+1)<vg_pt->width && y<vg_pt->height ){
					rb = pix_pt[x+1+y*width].r ;
					pix_pt[x+1+y*width].r = mix_col(rb,r,tran2,VALUE_MAX) ;
					gb = pix_pt[x+1+y*width].g ;
					pix_pt[x+1+y*width].g = mix_col(gb,g,tran2,VALUE_MAX) ;
					bb = pix_pt[x+1+y*width].b ;
					pix_pt[x+1+y*width].b = mix_col(bb,b,tran2,VALUE_MAX) ;
				}
			}
		}
	}else{
		if( sy>0 ){
			for( i=0 ; i<=dx ; i++ ){
				tran1=(dy*(i*256)/dx) % 256 ;
				tran2=VALUE_MAX-tran1 ;
				tran1=g_tbl[tran1] ;
				tran2=g_tbl[tran2] ;
				y=exec_info->y0 + (dy*i/dx) ;
				x=exec_info->x0 + i ;
				if( x>=0 && y>=0 && x<vg_pt->width && y<vg_pt->height ){
					rb = pix_pt[x+y*width].r ;
					pix_pt[x+y*width].r = mix_col(rb,r,tran1,VALUE_MAX) ;
					gb = pix_pt[x+y*width].g ;
					pix_pt[x+y*width].g = mix_col(gb,g,tran1,VALUE_MAX) ;
					bb = pix_pt[x+y*width].b ;
					pix_pt[x+y*width].b = mix_col(bb,b,tran1,VALUE_MAX) ;
				}

				if( x>=0 && (y+1)>=0 && x<vg_pt->width && (y+1)<vg_pt->height ){
					rb = pix_pt[x+(y+1)*width].r ;
					pix_pt[x+(y+1)*width].r = mix_col(rb,r,tran2,VALUE_MAX) ;
					gb = pix_pt[x+(y+1)*width].g ;
					pix_pt[x+(y+1)*width].g = mix_col(gb,g,tran2,VALUE_MAX) ;
					bb = pix_pt[x+(y+1)*width].b ;
					pix_pt[x+(y+1)*width].b = mix_col(bb,b,tran2,VALUE_MAX) ;
				}
			}
		}else{
			for( i=0 ; i<=dx ; i++ ){
				tran1=(dy*(i*256)/dx) % 256 ;
				tran2=VALUE_MAX-tran1 ;
				tran1=g_tbl[tran1] ;
				tran2=g_tbl[tran2] ;
				y=exec_info->y0 - (dy*i/dx) ;
				x=exec_info->x0 + i ;
				if( x>=0 && y>=0 && x<vg_pt->width && y<vg_pt->height ){
					rb = pix_pt[x+y*width].r ;
					pix_pt[x+y*width].r = mix_col(rb,r,tran1,VALUE_MAX) ;
					gb = pix_pt[x+y*width].g ;
					pix_pt[x+y*width].g = mix_col(gb,g,tran1,VALUE_MAX) ;
					bb = pix_pt[x+y*width].b ;
					pix_pt[x+y*width].b = mix_col(bb,b,tran1,VALUE_MAX) ;
				}

				if( x>=0 && (y-1)>=0 && x<vg_pt->width && (y-1)<vg_pt->height ){
					rb = pix_pt[x+(y-1)*width].r ;
					pix_pt[x+(y-1)*width].r = mix_col(rb,r,tran2,VALUE_MAX) ;
					gb = pix_pt[x+(y-1)*width].g ;
					pix_pt[x+(y-1)*width].g = mix_col(gb,g,tran2,VALUE_MAX) ;
					bb = pix_pt[x+(y-1)*width].b ;
					pix_pt[x+(y-1)*width].b = mix_col(bb,b,tran2,VALUE_MAX) ;
				}
			}
		}
	}

	free( g_tbl ) ;
	return( NORMAL_EXIT ) ;
}
