/**********************************************************************
  JPEG[h
  $Id: load_jpg.c,v 1.5 1998/11/20 15:11:21 TANE Exp $
**********************************************************************/
#include	"common.h"
#include	"vg_getput.h"
#include	"ovlap.h"
#include	"funcs.h"
#include	<jpeglib.h>

int	load_jpg( struct VGRAM_STRUCT *vg_pt, char *file , struct LD_MODE_STRUCT *ld_md )
{
unsigned char	*tmp_buff ;
struct	jpeg_decompress_struct cinfo;
struct	jpeg_error_mgr jerr ;

FILE	*fp;
struct	GETPUT_MODE	mode ;
int		y ;

	if( (fp=fopen(file, "rb"))==NULL ){
		fprintf(stderr,"t@C %s I[vł܂\n",file) ;
		return(FILE_OPEN_ERROR) ;
	}
	init_mode( &mode ) ;

	cinfo.err = jpeg_std_error(&jerr);
	jpeg_create_decompress(&cinfo);
	jpeg_stdio_src(&cinfo, fp);
	jpeg_read_header(&cinfo, TRUE);
	jpeg_start_decompress(&cinfo);

	tmp_buff = malloc( cinfo.output_width * cinfo.output_components ) ;
	if( tmp_buff == NULL ){
		fprintf(stderr,"Ɨ̈mۂł܂ł\n") ;
		jpeg_finish_decompress(&cinfo);
		jpeg_destroy_decompress(&cinfo);
		fclose( fp );
		return(WORK_MEM_ALLOC_ERROR) ;
	}

	mode.mask = ld_md->mask ;
	mode.rev  = ld_md->rev  ;
	mode.tran = ld_md->tran  ;
	mode.Gr   = ld_md->lr  ;
	mode.Gg   = ld_md->lg  ;
	mode.Gb   = ld_md->lb  ;
	switch( ld_md->oper ){
		case OVLAP_MONO :
			mode.oper = VG_TO_MONO ;
			break ;
		case OVLAP_MONOB :
			mode.oper = VG_TO_MONOB ;
			break ;
		case OVLAP_ATTR :
			mode.oper = VG_TO_A ;
			break ;
	}
	if( ld_md->vector == ROT90_LOAD ){
		int	tmpval ;
		mode.vector = VERTICAL ;
		tmpval=ld_md->px ;
		ld_md->px = ld_md->py ;
		ld_md->py = tmpval ;
	}

	switch( cinfo.output_components ){
		case 1:
			mode.buf_type = GRAY_8BIT ;
			break ;
		case 3:
			mode.buf_type = RGB_8BIT ;
			break ;
		default:
			fprintf(stderr,"layman:unsupported bpp\n") ;
			return( NORMAL_EXIT ) ;
	}

	y=ld_md->py ;
	while( cinfo.output_scanline < cinfo.output_height ){
		jpeg_read_scanlines(&cinfo, (JSAMPARRAY)&tmp_buff, 1 );
		vg_put_rect( vg_pt , tmp_buff , ld_md->px , y , cinfo.image_width , 1 , &mode ) ;
		y++ ;
	}

	jpeg_finish_decompress(&cinfo);
	jpeg_destroy_decompress(&cinfo);

	free( tmp_buff ) ;
	fclose( fp );

	return( NORMAL_EXIT );
}
