/**********************************************************************
  PNG[h
  $Id: load_png.c,v 1.6 1999/09/19 03:45:17 TANE Exp $
**********************************************************************/
#include	"common.h"
#include	"vg_getput.h"
#include	"ovlap.h"
#include	"funcs.h"
#include	"png.h"

#define	RGB		0
#define	GRAY	1
#define	INDEXED	2

int	load_png( struct VGRAM_STRUCT *vg_pt, char *file , struct LD_MODE_STRUCT *ld_md )
{
int		i, j, y ;
int		bpp ;			/* Bytes per pixel */
int		image_type ;	/* Type of image */
int		num_passes ;	/* Number of interlace passes in file */
int		pass ;			/* Current pass in file */

FILE		*fp;		/* File pointer */
png_structp	pp;			/* PNG read pointer */
png_infop	info;		/* PNG info pointers */

struct	GETPUT_MODE	mode ;
unsigned char	*pixel_buf[2] ;
unsigned char	**pixels ;

	if( (fp=fopen(file, "rb"))==NULL ){
		fprintf(stderr,"t@C %s I[vł܂\n",file) ;
		return(FILE_OPEN_ERROR) ;
	}

	init_mode( &mode ) ;

	pp   = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
	info = png_create_info_struct(pp);
	png_init_io( pp, fp );

	png_read_info( pp, info );
	if( info->bit_depth < 8 ){
		png_set_packing(pp);
		png_set_expand(pp);
		if( info->valid & PNG_INFO_sBIT ) png_set_shift(pp, &(info->sig_bit));
	}else{
		if( info->bit_depth == 16 ) png_set_strip_16(pp);
	}

	num_passes = png_set_interlace_handling(pp);

	mode.mask = ld_md->mask ;
	mode.rev  = ld_md->rev  ;
	mode.tran = ld_md->tran  ;
	switch( ld_md->oper ){
		case OVLAP_MONO :
			mode.oper = VG_TO_MONO ;
			break ;
		case OVLAP_MONOB :
			mode.oper = VG_TO_MONOB ;
			break ;
		case OVLAP_ATTR :
			mode.oper = VG_TO_A ;
			break ;
	}
	if( ld_md->vector == ROT90_LOAD ){
		int	tmpval ;
		mode.vector = VERTICAL ;
		tmpval=ld_md->px ;
		ld_md->px = ld_md->py ;
		ld_md->py = tmpval ;
	}

	switch( info->color_type ){
		case PNG_COLOR_TYPE_RGB :		/* RGB */
			bpp           = 3;
			image_type    = RGB;
			mode.buf_type = RGB_8BIT ;
			break;

		case PNG_COLOR_TYPE_RGB_ALPHA :	/* RGBA */
			if( ld_md->with_alpha == ON ){
				bpp           = 4;
				image_type    = RGB;
				mode.buf_type = RGBA_8BIT ;
			}else{
				png_set_strip_alpha(pp) ;
				bpp           = 3;
				image_type    = RGB;
				mode.buf_type = RGB_8BIT ;
			}
			break;

		case PNG_COLOR_TYPE_GRAY :		/* Grayscale */
			bpp           = 1;
			image_type    = GRAY;
			mode.buf_type = GRAY_8BIT ;
			break;

		case PNG_COLOR_TYPE_GRAY_ALPHA :	/* Grayscale + alpha */
			png_set_strip_alpha(pp) ;		/* vg_put_rectgray+alphaΉ̈alpha͖strip */
			bpp           = 1;
			image_type    = GRAY;
			mode.buf_type = GRAY_8BIT ;
			break;

		case PNG_COLOR_TYPE_PALETTE :	/* Indexed */
			bpp           = 3;
			image_type    = INDEXED;
			mode.buf_type = RGB_8BIT ;
			break;

		default :
			bpp           = 3;
			image_type    = RGB;
			mode.buf_type = RGB_8BIT ;
	}

	pixel_buf[0] = malloc( info->width * bpp ) ;
	pixel_buf[1] = malloc( info->width * bpp ) ;
	if( pixel_buf[0]==NULL || pixel_buf[1]==NULL ){
		fprintf(stderr,"Ɨ̈mۂł܂ł\n") ;
		free( pixel_buf[0] ) ;
		free( pixel_buf[1] ) ;
		png_destroy_read_struct(&pp, &info, NULL);
		fclose(fp);
		return(WORK_MEM_ALLOC_ERROR) ;
	}

	pixels = &pixel_buf[0] ;
	for( pass = 0 ; pass < num_passes ; pass++ ){
		for( y=ld_md->py,j=0 ; j< info->height ; y++,j++ ){
			png_read_rows( pp, pixels, NULL, 1 );
			if( image_type == INDEXED ){
				unsigned char  *buf_src , *buf_dst , *palet ;
				buf_dst = pixel_buf[1] ;
				buf_src = pixel_buf[0] ;
				palet = (unsigned char*)info->palette ;
				for( i=0 ; i<info->width ; i++ ){
					buf_dst[i*3]   = palet[ buf_src[i]*4   ] ;
					buf_dst[i*3+1] = palet[ buf_src[i]*4+1 ] ;
					buf_dst[i*3+2] = palet[ buf_src[i]*4+2 ] ;
				}
				vg_put_rect( vg_pt , pixel_buf[1] , ld_md->px , y, info->width , 1 , &mode ) ;
			}else{
				vg_put_rect( vg_pt , pixel_buf[0] , ld_md->px , y, info->width , 1 , &mode ) ;
			}

		}
    }

	png_read_end(pp, info);
	png_destroy_read_struct(&pp, &info, NULL);

	free( pixel_buf[0] ) ;
	free( pixel_buf[1] ) ;
	fclose(fp);

	return( NORMAL_EXIT );
}
/**********************************************************************
 ʃvOCɈڐAĂ C^[[XPNG̑ΉsSȎo(
 ĂĂ̂H)
 Avg_get/put_rect gpĂ֌WőΉɖʓ|Ȃ̂őΉ
 ȂBCtƑΉĂ܂Ă(xꂽlȋCɂȂ)
  vOCgpăC^[[XPNG͂œǂł炤Ƃ悤B

 vOڐAɋCÂɂƂꂽ(^^;
**********************************************************************/

