/**********************************************************************
  SIMt@C̃[h && x[Xʂւ̍
  $Id: load_sim.c,v 1.7 1999/08/26 16:15:38 TANE Exp $
**********************************************************************/

#include	"common.h"
#include	"ovlap.h"
#include	"funcs.h"
#include	"saifile.h"

#define	HEADER_STR		"SAI_PLAN"
#define	HEADER_STR_LEN	8
#define	BUFF_DIV_MAX	1024

int	load_sim( struct VGRAM_STRUCT *vg_pt, char *file , struct LD_MODE_STRUCT *ld_md )
{
short	x,y ;
short	i,n,flag ;
unsigned char	header_str[] = HEADER_STR ;
SAIHEADex	header ;

unsigned char	r,g,b,a ;		/* ̃J[ */
unsigned char	rb,gb,bb,ab ;	/* x[XJ[ */
unsigned char	rc,gc,bc,ac ;	/* JgJ[ */

struct	PIX_STRUCT	*pix_pt ;
unsigned char	*tmp_file_pt ;
FILE *ifp;

register short	vg_width ;
unsigned char	*in_img_tmp_pt ;
struct	ADJUST_STRUCT	adjust ;
int		img_dt_size ;
int		buff_div_num ;	/*** Height ***/
int		oper_line_num ;
short	vg_cur_line ;

	if( (ifp = fopen( file , "rb" )) == NULL ){
		fprintf(stderr,"t@C %s I[vł܂\n",file) ;
		return(FILE_OPEN_ERROR) ;
	}
	fread( &header , sizeof(SAIHEADex) , 1, ifp ) ;
	for( i=0 , flag=VALID ; i<HEADER_STR_LEN ; i++ ){
		if( header.sai_id[i] != header_str[i] ) flag=INVALID ;
	}

	if( flag == INVALID ){
		fprintf(stderr,"SIMtH[}bgł͂܂\n") ;
		return(SIM_FORMAT_ERROR) ;
	}

	adjust.vg_pt = vg_pt ;
	adjust.px = ld_md->px ;
	adjust.py = ld_md->py ;
	adjust.img_width  = header.nx ;
	adjust.img_height = header.ny ;
	if( ld_adjust( &adjust ) == OUT_OF_VGRAM ){
		fclose(ifp) ;
		return( NORMAL_EXIT ) ;
	}

	img_dt_size  = 0 ;
	in_img_tmp_pt = NULL ;
	for( buff_div_num=1 ; buff_div_num<=BUFF_DIV_MAX ; buff_div_num += buff_div_num ){
		img_dt_size = adjust.img_width * (adjust.height/buff_div_num) ;
		in_img_tmp_pt = malloc( img_dt_size ) ;
		if( in_img_tmp_pt != NULL ) break ;
	}
	if( in_img_tmp_pt == NULL ){
		fprintf(stderr,"Ɨ̈mۂł܂ł\n") ;
		return(WORK_MEM_ALLOC_ERROR) ;
	}

	pix_pt = vg_pt->pix ;
	vg_width = vg_pt->width ;
	fseek( ifp,(adjust.img_width * adjust.height_adjust_U), SEEK_CUR ) ;
	oper_line_num = adjust.height / buff_div_num ;
	vg_cur_line = adjust.sy ;

	for( n=0 ; n<=buff_div_num ; n++ ){
		if( n == buff_div_num ){ /***ubN[vZ***/
			if( (adjust.height % buff_div_num) == 0 ) break ; /***[ꍇ***/
			img_dt_size = adjust.img_width * (adjust.height % buff_div_num) ;
			oper_line_num = adjust.height % buff_div_num ;
		}
		fread( in_img_tmp_pt , img_dt_size , 1 , ifp ) ;
		tmp_file_pt = in_img_tmp_pt ;
		for( y=0 ; y<oper_line_num ; y++,vg_cur_line++ ){
			tmp_file_pt += adjust.width_adjust_L ;
			for( x=adjust.sx ; x<(adjust.sx+adjust.width) ; x++ ){
				gc = *tmp_file_pt ;
				rc = *tmp_file_pt ;
				bc = *tmp_file_pt ;
				ac = *tmp_file_pt ;
				tmp_file_pt++ ;
				switch( ld_md->oper ){
					case OVLAP_MASK :
					case OVLAP_COL  :
						if( ld_md->rev == ON ) ac = VALUE_MAX - ac ;
						rb = pix_pt[vg_cur_line*vg_width+x].r ;
						r = mix_col( rb , ac , ld_md->tran , VALUE_MAX ) ;
						pix_pt[vg_cur_line*vg_width+x].r = r ;

						gb = pix_pt[vg_cur_line*vg_width+x].g ;
						g = mix_col( gb , ac , ld_md->tran , VALUE_MAX ) ;
						pix_pt[vg_cur_line*vg_width+x].g = g ;

						bb = pix_pt[vg_cur_line*vg_width+x].b ;
						b = mix_col( bb , ac , ld_md->tran , VALUE_MAX ) ;
						pix_pt[vg_cur_line*vg_width+x].b = b ;
						break ;
					case OVLAP_MASK_TO_ATTR :
					case OVLAP_ATTR :
						if( ld_md->rev != ON ) ac = VALUE_MAX - ac ;
						ab = pix_pt[vg_cur_line*vg_width+x].a ;
						a = limit_max( (short)(ab + ac) , VALUE_MAX ) ;
						pix_pt[vg_cur_line*vg_width+x].a = a ;
						break ;
				}
			}
			tmp_file_pt += adjust.width_adjust_R ;
		}
	}

	free( in_img_tmp_pt ) ;
	fclose( ifp ) ;
	return( NORMAL_EXIT ) ;
}
