/****************************************************************
 *	EX-Window Ver.2.0 X file.
 *	(c) i.kikuchi & i.yoshida
 *
  24bit Color modified for layman
  $Id: parabola.c,v 1.7 1999/05/31 15:44:38 TANE Exp $
*****************************************************************/

#include	"common.h"
#include	"funcs.h"
#include	"parabola.h"
#include	"3DMap.h"
#include	<math.h>

#ifndef	PI
#define	PI	3.1415926535898
#endif

#include	"Equation.h"

int		parabola_lightset( char* , struct Mapping_Vector * );
int		Parabola_main( struct VGRAM_STRUCT * , struct Mapping_Vector * );
int		parabola_load( char* , struct Mapping_Vector * );

static	struct {
	int	type;
	char	str[36];
	int	para[2];
} ctrl[] = {
	{ 8,	"ʌa",	 	{	-3, 0 }, },	/* ID  0 */
	{ 7,	"",			 	{	 1, 0 }, }, /* ID  1 */
	{ 8,	"ʌa",	 	{	-3, 0 }, }, /* ID  2 */
	{ 7,	"",			 	{	 1, 0 }, }, /* ID  3 */
	{ 8,	"",		 	{	-3, 0 }, }, /* ID  4 */
	{ 7,	"",			 	{	 1, 0 }, },	/* ID  5 */
	{ 8,	"X",	 	{	-3, 0 }, },	/* ID  6 */
	{ 3,	"",			 	{65534, 0 }, },	/* ID  7 */
	{ 7,	"",			 	{	 1, 0 }, },	/* ID  8 */
	{ 8,	"]",	 	{	-3, 0 }, },	/* ID  9 */
	{ 3,	"",			 	{65534, 0 }, },	/* ID 10 */
	{ 7,	"",			 	{	 1, 0 }, },	/* ID 11 */
	{ 5,	"",			 	{	 1, 0 }, },	/* ID 12 */
	{ 8,	"Shading",	 	{	-3, 0 }, },	/* ID 13 */
	{ 2,	"ײèݸސݒ",	{	 1, 0 }, },	/* ID 14 */
	{ 5,	"",			 	{	 0, 0 }, },	/* ID 15 */
	{ 8,	"Mapping",	 	{	-3, 0 }, },	/* ID 16 */
	{ 5,	"",			 	{	 1, 0 }, },	/* ID 17 */
	{ 8,	"Texture",	 	{	-3, 0 }, },	/* ID 18 */
	{ 5,	"",			 	{	 0, 0 }, },	/* ID 19 */
	{ 8,	"Bump",		 	{	-3, 0 }, },	/* ID 20 */
	{ 5,	"",			 	{	 1, 0 }, },	/* ID 21 */
	{ 8,	"Forward",	 	{	-3, 0 }, },	/* ID 22 */
	{ 5,	"",			 	{	 1, 0 }, },	/* ID 23 */
	{ 8,	"Back",		 	{	-3, 0 }, },	/* ID 24 */
	{ 6,	"",			 	{	 1, 1 }, },	/* ID 25 */
	{ 2,	"s",		 	{	 1, 0 }, },	/* ID 26 */
	{ 8,	"yʒu",	 	{	-3, 0 }, },	/* ID 27 */
	{ 3,	"",			 	{65534, 0 }, },	/* ID 28 */
	{ 7,	"",			 	{	 1, 0 }, },	/* ID 29 */
	{ 2,	"File",		 	{	 1, 0 }, },	/* ID 30 */
	{ 2,	"2",		 	{	 1, 0 }, }	/* ID 31 */
};	

typedef enum CtrlNo {
	CtrlLB_TOPR,
	CtrlTB_TOPR,
	CtrlLB_BOTR,
	CtrlTB_BOTR,
	CtrlLB_HEIGHT,
	CtrlTB_HEIGHT,
	CtrlLB_PITCH,
	CtrlHS_PITCH,
	CtrlTB_PITCH,
	CtrlLB_BANK,
	CtrlHS_BANK,
	CtrlTB_BANK,
	CtrlCB_SHADE,
	CtrlLB_SHADE,
	CtrlBT_LIGHTSET,
	CtrlCB_MAP,
	CtrlLB_MAP,
	CtrlCB_TEXTURE,
	CtrlLB_TEXTURE,
	CtrlCB_BUMP,
	CtrlLB_BUMP,
	CtrlCB_FORWARD,
	CtrlLB_FORWARD,
	CtrlCB_BACK,
	CtrlLB_BACK,
	CtrlCC_SAMPLE,
	CtrlBT_EXEC,
	CtrlLB_ZPOS,
	CtrlHS_ZPOS,
	CtrlTB_ZPOS,
	CtrlBT_FILE,
	CtrlBT_BUMPLEVEL,
} CtrlNo;

int		shadow_mode , hilight_mode , draw_mode , ovlap_mode ;

/**********************************************************************
  Parabola lݒ
***********************************************************************/
int	parabola( struct VGRAM_STRUCT *vg_pt , struct PARABOLA_EXEC_STRUCT *exec_info )
{
struct	Mapping_Vector map_dt , *map_pt ;

	map_pt = &map_dt ;
	if( exec_info->rend_file[0] != '\0' ){
		if( parabola_load( exec_info->rend_file , map_pt ) != NORMAL_EXIT ){
			fprintf( stderr,"t@C %s I[vł܂łBftHglgp܂B\n",exec_info->rend_file ) ;
		}
	}
	if( exec_info->light_file[0] != '\0' ){
		if( parabola_lightset( exec_info->light_file , map_pt ) != NORMAL_EXIT ){
			fprintf( stderr,"t@C %s I[vł܂łBftHglgp܂B\n",exec_info->light_file ) ;
		}
	}

	map_pt->sx0 = exec_info->sx ;
	map_pt->sy0 = exec_info->sy ;
	map_pt->ex0 = exec_info->ex ;
	map_pt->ey0 = exec_info->ey ;
	map_pt->org_r = exec_info->r ;
	map_pt->org_g = exec_info->g ;
	map_pt->org_b = exec_info->b ;

	shadow_mode = exec_info->shadow_mode ;
	hilight_mode = exec_info->hilight_mode ;
	draw_mode  = exec_info->draw_mode ;
	ovlap_mode = exec_info->ovlap_mode ;

	if( draw_mode == MAPPING ) ctrl[CtrlCB_MAP].para[0] = 1 ;
	if( draw_mode == NO_MAPPING ) ctrl[CtrlCB_MAP].para[0] = 0 ;
	if( exec_info->shade_mode == OFF ) ctrl[CtrlCB_SHADE].para[0] = 0 ;

	Parabola_main( vg_pt , map_pt ) ;

	return( NORMAL_EXIT );
}

/**********************************************************************
  Parabola _O{
***********************************************************************/
int	Parabola_main( struct VGRAM_STRUCT *vg_pt , struct Mapping_Vector *map_pt )
{
int	x, y, ox1, oy1, ox2, oy2, x1, y1;
int	dx0, dy0, dx1, dx2, dy, sx, ex, ty, by;
double	x00, y00, x01, y01, x02, y02, xx, yy, zz, rx, sinth, costh, tanth;
double	k1, k2, k, k3, ly, sinrth, cosrth;
int	i, j, l, result, facex, facey, tmp, thr;
double	a[5], ans0[4], ans[4];

int		cx, cy, r0, r1, zpos ;
int		sx0, sy0, ex0, ey0 ;
double	vx0, vy0, vz0, l0, ll ;
double	hl, hk ;
int		lcx, lcy, lcz, conelight ;
int		th, rth, bumplevel ;
double	vx, vy, vz;
unsigned int	org_r, org_g, org_b ;

int		width,height ;
struct	VGRAM_STRUCT vg_tmp , *vg_tmp_pt ;
int		exec_status ;

	vg_tmp_pt = &vg_tmp ;
	vg_alloc( vg_tmp_pt , vg_pt->width , vg_pt->height ) ;
	if( vg_tmp_pt->pix == NULL ){
		fprintf(stderr,"Ɨ̈̊mۂɎs܂\n") ;
		return( VGRAM_WORK_ALLOC_ERROR ) ;
	}
	if( ovlap_mode == OFF ){
		vg_clr( vg_tmp_pt , 0,0,0, VALUE_MAX ) ;
	}else{
		vg_cpy( vg_tmp_pt , vg_pt ) ;
	}

	cx = map_pt->cx ;
	cy = map_pt->cy ;
	r0 = map_pt->r0 ;
	r1 = map_pt->r1 ;
	dx1 = map_pt->dx1 ;
	dx2 = map_pt->dx2 ;
	dy = map_pt->dy ;
	zpos = map_pt->zpos ;
	sx0 = map_pt->sx0 ;
	sy0 = map_pt->sy0 ;
	ex0 = map_pt->ex0 ;
	ey0 = map_pt->ey0 ;
	vx0 = map_pt->vx0 ;
	vy0 = map_pt->vy0 ;
	vz0 = map_pt->vz0 ;
	l0 = map_pt->l0 ;
	ll = map_pt->ll ;
	hl = map_pt->hl ;
	hk = map_pt->hk ;
	lcx = map_pt->lcx ;
	lcy = map_pt->lcy ;
	lcz = map_pt->lcz ;
	conelight = map_pt->conelight ;
	th = map_pt->th ;
	rth = map_pt->rth ;
	bumplevel = map_pt->bumplevel ;
	vx = map_pt->vx ;
	vy = map_pt->vy ;
	vz = map_pt->vz ;
	org_r = map_pt->org_r ;
	org_g = map_pt->org_g ;
	org_b = map_pt->org_b ;

	width  = vg_pt->width ;
	height = vg_pt->height ;

	result = 0 ;

	if( conelight ){
		vx0 = (lcx-cx)?(lcx-cx):0.0;
		vy0 = (lcy-cy)?(lcy-cy):0.0;
		vz0 = (zpos-lcz)?(zpos-lcz):0.0;
		if( vx0==0.0 && vy0==0.0 && vz0==0.0 ) vz0 = 1.0;
	}
	if( th==90 ) k = 89.5; else if( th==-90 ) k = -89.5; else k = (double)th;
	sinth = sin( (double)PI*k/180.0 );
	costh = cos( (double)PI*k/180.0 );
	tanth = tan( (double)PI*k/180.0 );
	sinrth = sin( (double)PI*rth/180.0 );
	cosrth = cos( (double)PI*rth/180.0 );
	dx0 = ex0-sx0;
	dy0 = ey0-sy0;
	if( th>0 ){
		if( ctrl[CtrlCB_BACK].para[0] ){
			ty = -(int)((double)dx1/2.0*sinth+(double)dy*costh)-1;
			tmp = -(int)((double)dx2/2.0*sinth)-1;
			if( ty>tmp ) ty = tmp;
		} else ty = -dy-1;
		if( ctrl[CtrlCB_FORWARD].para[0] ){
			by = (int)((double)dx2/2.0*sinth)+1;
			tmp = (int)((double)dx1/2.0*sinth)+1;
			if( by<tmp ) by = tmp;
		} else by = 1;
	} else {
		if( ctrl[CtrlCB_FORWARD].para[0] ){
			ty = -(int)((double)dx1/2.0*-sinth+(double)dy*costh)-1;
			tmp = -(int)((double)dx2/2.0*-sinth)-1;
			if( ty>tmp ) ty = tmp;
		} else ty = -dy-1;
		if( ctrl[CtrlCB_BACK].para[0] ){
			by = (int)((double)dx2/2.0*-sinth)+1;
			tmp = (int)((double)dx1/2.0*-sinth)+1;
			if( by<tmp ) by = tmp;
		} else by = 1;
	}
	sx = (((dx1>dx2)?dx1:dx2)+1)/2;
	ty += (double)dy/2.0*costh;
	by += (double)dy/2.0*costh;
	ans0[0] = sx*cosrth-ty*sinrth;
	ans0[1] = -sx*cosrth-ty*sinrth;
	ans0[2] = sx*cosrth-by*sinrth;
	ans0[3] = -sx*cosrth-by*sinrth;
	qsort( ans0, 4, sizeof(double), compare );
	ans[0] = ty*cosrth+sx*sinrth;
	ans[1] = by*cosrth+sx*sinrth;
	ans[2] = ty*cosrth-sx*sinrth;
	ans[3] = by*cosrth-sx*sinrth;
	qsort( ans, 4, sizeof(double), compare );
	sx = ans0[3];
	ex = ans0[0];
	ty = ans[3];
	by = ans[0];
	k1 = -(double)dy*4.0/(dx1-dx2)/(dx1-dx2);
	k3 = 0.25/k1/k1;
	k = fabs(dx1-dx2)/2.0;
	ly = k*sqrt(k+k3)+k3*log(k+sqrt(k*k+k3))-k3*log(sqrt(k3));
	for( x=sx; x<=ex; x++ ){
		x1 = cx+x;
		if( x1<0 || x1>(width-1) ) continue;
		for( y=ty; y<=by; y++ ){
			y1 = cy+y;
			if( y1<0 || y1>(height-1) ) continue;
			x00 = (double)x*cosrth+(double)y*sinrth;
			y00 = (double)y*cosrth-(double)x*sinrth-(double)dy/2.0*costh;
			x01 = x00-0.5;
			y01 = y00-0.5;
			x02 = x00+0.5;
			y02 = y00+0.5;

			k2 = k1*x00*x00+k1*dx2*dx2/4.0-y00/costh;
			a[0] = k1*k1;
			a[1] = 2.0*k1*tanth;
			a[2] = tanth*tanth+2.0*k1*k2-k1*k1*dx2*dx2;
			a[3] = 2.0*k2*tanth;
			a[4] = k2*k2-k1*k1*dx2*dx2*x00*x00;
			j = Ferra( a, ans0 );
			if( j==0 ) continue;
			if( j==2 || dx1<dx2 ) l = 1; else l = 3;
			thr = 0;
			for( i=0; i<j; i+=l ){
				zz = ans0[i];
				if( zz>=0.0 ){
					if( ctrl[CtrlCB_FORWARD].para[0]==0 ) continue;
					facex = 0;
				} else {
					if( ctrl[CtrlCB_BACK].para[0]==0 ) continue;
					facex = 1;
				}
				xx = x00;
				yy = y00/costh-zz*tanth;
				if( -yy>dy ) continue;
				rx = sqrt( xx*xx+zz*zz );
				if( dx1>dx2 ){ if( rx*2<dx2 ) continue; }
				else if( rx*2>dx2 ) continue;
				vx = xx-xx*(double)dx2/2.0/rx;
				vy = -1.0/2.0/k1;
				zz = zz-zz*(double)dx2/2.0/rx;
				vz = zz*costh-vy*sinth;
				vy = vy*costh+zz*sinth;
				k = vx*cosrth-vy*sinrth;
				vy = vy*cosrth+vx*sinrth;
				vx = k;
				if( vz<0.0 ){
					vx = -vx; vy = -vy; vz = -vz;
					facey = 1;
				} else facey = 0;

				if( ctrl[CtrlCB_MAP].para[0] ){
					k2 = k1*x01*x01+k1*dx2*dx2/4.0-y01/costh;
					a[0] = k1*k1;
					a[1] = 2.0*k1*tanth;
					a[2] = tanth*tanth+2.0*k1*k2-k1*k1*dx2*dx2;
					a[3] = 2.0*k2*tanth;
					a[4] = k2*k2-k1*k1*dx2*dx2*x01*x01;
					if( j==Ferra( a, ans ) ) zz = ans[i]; else zz = ans0[i];
					xx = x01;
					yy = y01/costh-zz*tanth;
					rx = sqrt( xx*xx+zz*zz );
					ox1 = (int)((double)dx0*asin(xx/rx)/(double)PI*16.0)+(sx0+ex0)*8;
					k = fabs(rx-(double)dx2/2.0);
					oy1 = (int)(ey0-(k*sqrt(k+k3)+k3*log(k+sqrt(k*k+k3))-k3*log(sqrt(k3)))*(double)dy0/ly)*16.0;

					k2 = k1*x02*x02+k1*dx2*dx2/4.0-y02/costh;
					a[0] = k1*k1;
					a[1] = 2.0*k1*tanth;
					a[2] = tanth*tanth+2.0*k1*k2-k1*k1*dx2*dx2;
					a[3] = 2.0*k2*tanth;
					a[4] = k2*k2-k1*k1*dx2*dx2*x02*x02;
					if( j==Ferra( a, ans ) ) zz = ans[i]; else zz = ans0[i];
					xx = x02;
					yy = y02/costh-zz*tanth;
					rx = sqrt( xx*xx+zz*zz );
					ox2 = (int)((double)dx0*asin(xx/rx)/(double)PI*16.0)+(sx0+ex0)*8;
					k = fabs(rx-(double)dx2/2.0);
					oy2 = (int)(ey0-(k*sqrt(k+k3)+k3*log(k+sqrt(k*k+k3))-k3*log(sqrt(k3)))*(double)dy0/ly)*16.0;
					if( facex ){ ox1 = (sx0+ex0)*16.0-ox1; ox2 = (sx0+ex0)*16.0-ox2; }

					if( ox1>ox2 ){ tmp = ox1; ox1 = ox2; ox2 = tmp; }
					if( oy1>oy2 ){ tmp = oy1; oy1 = oy2; oy2 = tmp; }

					map_pt->vx0 = vx0 ;
					map_pt->vy0 = vy0 ;
					map_pt->vz0 = vz0 ;
					map_pt->l0 = l0 ;
					map_pt->ll = ll ;
					map_pt->hl = hl ;
					map_pt->hk = hk ;
					map_pt->vx = vx ;
					map_pt->vy = vy ;
					map_pt->vz = vz ;
					map_pt->bumplevel = bumplevel ;

					if( ctrl[CtrlCB_TEXTURE].para[0] )	/* Texture */
					result = TextureMap( ox1, oy1, ox2, oy2, vg_pt, map_pt );
					if( ctrl[CtrlCB_BUMP].para[0] )		/* Bump */
					result = BumpMap( ox1, oy1, ox2, oy2, facex, facey, vg_pt, map_pt );
				} else {
					if( draw_mode == LIGHTING_ONLY ){
						map_pt->r = vg_pt->pix[x1+y1*width].r ;
						map_pt->g = vg_pt->pix[x1+y1*width].g ;
						map_pt->b = vg_pt->pix[x1+y1*width].b ;
					}else{
						map_pt->r = org_r ;
						map_pt->g = org_g ;
						map_pt->b = org_b ;
					}
					result = 0;
				}
				if( result==0 ){
					map_pt->vx = vx ;
					map_pt->vy = vy ;
					if( ctrl[CtrlCB_SHADE].para[0] ) Shade( x1, y1, shadow_mode, hilight_mode, map_pt ) ;
					vg_tmp_pt->pix[x1+y1*width].r = map_pt->r ;
					vg_tmp_pt->pix[x1+y1*width].g = map_pt->g ;
					vg_tmp_pt->pix[x1+y1*width].b = map_pt->b ;
					if( ovlap_mode == OFF )	vg_tmp_pt->pix[x1+y1*width].a = 0 ;
					break ;
				}
			}
		}
	}
	vg_cpy( vg_pt , vg_tmp_pt ) ;
	exec_status = vg_free( vg_tmp_pt ) ;
	return( NORMAL_EXIT ) ;
}


/**********************************************************************
  Parabola _O`ǂݍ
***********************************************************************/
int	parabola_load( char *filename , struct Mapping_Vector *map_pt )
{
#include	"ParabolaItem.h"
	FILE	*fp;
	char	s[20];
	int	i;

	fp = fopen( filename, "rt" );
	if( fp==NULL ) return( FILE_OPEN_ERROR );

	do {
		fscanf( fp, "%s = ", s );
		for( i=0; i<ParabolaItemNum; i++ ){
			if( stricmp( s, ParabolaItem[i] )==0 ){
				switch( i ){
				case 0:	fscanf( fp, "%d\n", &(map_pt->cx) );
					break;
				case 1:	fscanf( fp, "%d\n", &(map_pt->cy) );
					break;
				case 2:	fscanf( fp, "%d\n", &(map_pt->dx1) );
					break;
				case 3:	fscanf( fp, "%d\n", &(map_pt->dx2) );
					break;
				case 4:	fscanf( fp, "%d\n", &(map_pt->dy) );
					break;
				case 5:	fscanf( fp, "%d\n", &(map_pt->th) );
					break;
				case 6:	fscanf( fp, "%d\n", &(map_pt->rth) );
					break;
				case 7:	fscanf( fp, "%d\n", &(map_pt->zpos) );
					break;
				case 8:	fscanf( fp, "%d\n", &ctrl[CtrlCB_SHADE].para[0] );
					break;
				case 9:	fscanf( fp, "%d\n", &ctrl[CtrlCB_MAP].para[0] );
					break;
				case 10:fscanf( fp, "%d\n", &ctrl[CtrlCB_TEXTURE].para[0] );
					break;
				case 11:fscanf( fp, "%d\n", &ctrl[CtrlCB_BUMP].para[0] );
					break;
				case 12:fscanf( fp, "%d\n", &(map_pt->bumplevel) );
					break;
				case 13:fscanf( fp, "%d\n", &ctrl[CtrlCB_FORWARD].para[0] );
					break;
				case 14:fscanf( fp, "%d\n", &ctrl[CtrlCB_BACK].para[0] );
					break;
				}
				break;
			}
		}
	} while( !feof( fp ) );
	fclose( fp );
	return( NORMAL_EXIT ) ;
}

/**********************************************************************
  Parabora CeBOǂݍ
***********************************************************************/
int	parabola_lightset( char *filename , struct Mapping_Vector *map_pt )
{
#include	"LightItem.h"
FILE	*fp;
char	s[20];
int	i;

	fp = fopen( filename, "rt" );
	if( fp==NULL ) return( FILE_OPEN_ERROR ) ;
	do {
		fscanf( fp, "%s = ", s );
		for( i=0; i<LightItemNum; i++ ){
			if( stricmp( s, LightItem[i] )==0 ){
				switch( i ){
				case 0:	fscanf( fp, "%lf\n", &(map_pt->vx0) );
					break;
				case 1:	fscanf( fp, "%lf\n", &(map_pt->vy0) );
					break;
				case 2:	fscanf( fp, "%lf\n", &(map_pt->vz0) );
					break;
				case 3:	fscanf( fp, "%lf\n", &(map_pt->ll) );
					break;
				case 4:	fscanf( fp, "%lf\n", &(map_pt->l0) );
					break;
				case 5:	fscanf( fp, "%lf\n", &(map_pt->hl) );
					break;
				case 6:	fscanf( fp, "%lf\n", &(map_pt->hk) );
					break;
				case 7:	fscanf( fp, "%d\n", &(map_pt->conelight) );
					break;
				case 8:	fscanf( fp, "%d\n", &(map_pt->lcx) );
					break;
				case 9:	fscanf( fp, "%d\n", &(map_pt->lcy) );
					break;
				case 10:fscanf( fp, "%d\n", &(map_pt->lcz) );
					break;
				}
				break;
			}
		}
	} while( !feof( fp ) );
	fclose( fp );
	return( NORMAL_EXIT ) ;
}


